local _G = getfenv(0)
local obj = _G.LibStub("LibDataBroker-1.1"):NewDataObject("PVP Timer", { type = "data source", label = "PVP", text = "" })

local format = _G.string.format
local floor = _G.floor
local SecondsToTimeAbbrev = _G.SecondsToTimeAbbrev

local time = nil

local f = CreateFrame("frame")
f:RegisterEvent("PLAYER_ENTERING_WORLD");
f:RegisterEvent("PLAYER_FLAGS_CHANGED");
f:SetScript("OnEvent", function()
	if IsPVPTimerRunning() then
		time = GetPVPTimer()	
	else
		time = nil
	end
	if UnitIsPVPFreeForAll("player") then
		obj.icon = "Interface\\TargetingFrame\\UI-PVP-FFA"
	else
		local faction = UnitFactionGroup("player")
		obj.icon = faction and "Interface\\TargetingFrame\\UI-PVP-"..faction
	end
end)

f:SetScript("OnUpdate", function(self, elapsed)
	if time then
		time = time - elapsed*1000
		if time < 0 then
			time = nil
		else
			local fmt, digit = SecondsToTimeAbbrev(floor(time/1000))
			obj.text = format(fmt, digit)
		end
	else
		obj.text = "Off"
	end
end)

